Ubuntu

kernel BUG at /build/buildd/linux-2.6.32/drivers/gpu/drm/i915/i915_gem_evict.c:183!

Reported by Lukav on 2011-08-18
22
This bug affects 3 people
Affects Status Importance Assigned to Milestone
linux (Ubuntu)
High
Seth Forshee
Lucid
Undecided
Seth Forshee

Bug Description

After upgrading to linux-image 2.6.32-34-generic my Xorg randomly freezes.
I can still log in remotely with ssh, but cannot restart Xorg gdm or use the kayboard to switch to vt1.

I found in the syslog this:
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704411] ------------[ cut here ]------------
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704419] kernel BUG at /build/buildd/linux-2.6.32/drivers/gpu/drm/i915/i915_gem_evict.c:183!
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704424] invalid opcode: 0000 [#1] SMP
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704430] last sysfs file: /sys/devices/pci0000:00/0000:00:1d.7/usb2/2-0:1.0/uevent
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704434] Modules linked in: rfcomm sco bridge stp bnep l2cap vboxnetadp vboxnetflt vboxdrv dm_crypt btusb bluetooth snd_hda_codec_via snd_hda_intel snd_hda_codec snd_hwdep snd_pcm_oss snd_mixer_oss snd_pcm snd_seq_dummy snd_seq_oss snd_seq_midi snd_rawmidi snd_seq_midi_event coretemp snd_seq hwmon_vid snd_timer snd_seq_device ppdev parport_pc asus_atk0110 snd soundcore snd_page_alloc lp parport dm_raid45 xor fbcon tileblit font bitblit softcursor vga16fb vgastate usbhid i915 r8169 hid drm_kms_helper intel_agp mii ahci pata_jmicron drm i2c_algo_bit video output agpgart ramzswap xvmalloc lzo_decompress lzo_compress
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704519]
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704525] Pid: 1351, comm: Xorg Not tainted (2.6.32-34-generic #73-Ubuntu) System Product Name
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704529] EIP: 0060:[<f8912b1d>] EFLAGS: 00213246 CPU: 1
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704549] EIP is at i915_gem_evict_something+0x16d/0x360 [i915]
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704554] EAX: 00000000 EBX: f14c3880 ECX: f6b4ee04 EDX: 01000000
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704557] ESI: ef6edcd0 EDI: ef6edcc8 EBP: ef6edce4 ESP: ef6edca4
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704561] DS: 007b ES: 007b FS: 00d8 GS: 00e0 SS: 0068
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704566] Process Xorg (pid: 1351, ti=ef6ec000 task=f1413fc0 task.ti=ef6ec000)
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704569] Stack:
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704571] 00000000 ef6edcd0 ef6edcb0 c3508dd0 f6b4e000 00001000 01000000 f6b4ee04
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704582] <0> f6b4e000 ef6edcc8 ef6edcc8 ef6edcd0 ef6edcd0 ee1ecc00 f3212480 00000000
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704594] <0> ef6edd18 f890cfdd 00000000 00000001 c3508dc0 000000b4 f6b4ee04 00001200
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704607] Call Trace:
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704629] [<f890cfdd>] ? i915_gem_object_bind_to_gtt+0x15d/0x310 [i915]
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704650] [<f890e747>] ? i915_gem_object_pin+0x127/0x140 [i915]
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704670] [<f890f98f>] ? i915_gem_object_pin_and_relocate+0x4f/0x3d0 [i915]
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704679] [<c013b2f6>] ? __dequeue_entity+0x26/0x50
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704701] [<f851ee70>] ? drm_gem_object_lookup+0x40/0x60 [drm]
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704722] [<f891037b>] ? i915_gem_do_execbuffer+0x40b/0xc40 [i915]
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704729] [<c01da2f7>] ? shmem_alloc_inode+0x17/0x30
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704736] [<c02f75be>] ? security_inode_alloc+0x1e/0x20
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704742] [<c034e034>] ? sub_alloc+0x64/0x170
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704764] [<f89116ab>] ? i915_gem_execbuffer+0x1ab/0x3d0 [i915]
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704784] [<f8911425>] ? i915_gem_init_object+0x25/0x100 [i915]
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704791] [<c035643d>] ? copy_from_user+0x3d/0x130
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704811] [<f851d80d>] ? drm_ioctl+0x29d/0x410 [drm]
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704834] [<f8911500>] ? i915_gem_execbuffer+0x0/0x3d0 [i915]
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704845] [<c01e6bb4>] ? __do_fault+0x274/0x490
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704851] [<c01a46b2>] ? cpu_quiet_msk+0x72/0x110
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704869] [<f851d570>] ? drm_ioctl+0x0/0x410 [drm]
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704878] [<c0218791>] ? vfs_ioctl+0x21/0x90
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704883] [<c0218a79>] ? do_vfs_ioctl+0x79/0x310
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704890] [<c058f0f0>] ? do_page_fault+0x160/0x3a0
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704895] [<c0218d77>] ? sys_ioctl+0x67/0x80
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704901] [<c01033ec>] ? syscall_call+0x7/0xb
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704905] Code: 7b 18 89 7b 1c eb cc 8d b4 26 00 00 00 00 8b 4d d4 8b 55 d8 8b 45 dc c7 04 24 00 00 00 00 e8 5b 36 c1 ff 85 c0 0f 85 da fe ff ff <0f> 0b eb fe 8d b4 26 00 00 00 00 8b 55 ec 3b 55 c4 74 d0 31 c0
Aug 18 10:43:14 lukav-desktop kernel: [ 57.704970] EIP: [<f8912b1d>] i915_gem_evict_something+0x16d/0x360 [i915] SS:ESP 0068:ef6edca4
Aug 18 10:43:14 lukav-desktop kernel: [ 57.705010] ---[ end trace 1fdb35395d02c9f9 ]---

ProblemType: Bug
DistroRelease: Ubuntu 10.04
Package: linux-image-2.6.32-34-generic 2.6.32-34.73
Regression: Yes
Reproducible: No
ProcVersionSignature: Ubuntu 2.6.32-34.73-generic 2.6.32.44+drm33.19
Uname: Linux 2.6.32-34-generic i686
AlsaVersion: Advanced Linux Sound Architecture Driver Version 1.0.21.
Architecture: i386
ArecordDevices:
 **** List of CAPTURE Hardware Devices ****
 card 0: Intel [HDA Intel], device 0: VT1708B Analog [VT1708B Analog]
   Subdevices: 2/2
   Subdevice #0: subdevice #0
   Subdevice #1: subdevice #1
AudioDevicesInUse: Error: command ['fuser', '-v', '/dev/dsp', '/dev/snd/by-path', '/dev/snd/controlC0', '/dev/snd/hwC0D0', '/dev/snd/pcmC0D0c', '/dev/snd/pcmC0D0p', '/dev/snd/pcmC0D1p', '/dev/snd/seq', '/dev/snd/timer', '/dev/sequencer2', '/dev/sequencer'] failed with exit code -9:
CRDA: Error: [Errno 2] Няма такъв файл или директория
Card0.Amixer.info:
 Card hw:0 'Intel'/'HDA Intel at 0xfe8f4000 irq 22'
   Mixer name : 'VIA VT1708B 8-Ch'
   Components : 'HDA:1106e721,104382ea,00100100'
   Controls : 35
   Simple ctrls : 19
Date: Thu Aug 18 11:01:27 2011
Frequency: Once a day.
HibernationDevice: RESUME=UUID=03077dce-674c-4b94-baf1-c12a49249fdc
MachineType: System manufacturer System Product Name
ProcCmdLine: BOOT_IMAGE=/boot/vmlinuz-2.6.32-34-generic root=UUID=c84939db-f205-4566-a668-aa1c1922d512 ro quiet splash
ProcEnviron:
 LANGUAGE=bg_BG:en
 PATH=(custom, user)
 LANG=bg_BG.UTF-8
 SHELL=/bin/bash
RelatedPackageVersions: linux-firmware 1.34.10
RfKill:
 0: hci0: Bluetooth
  Soft blocked: no
  Hard blocked: no
SourcePackage: linux
WpaSupplicantLog:

dmi.bios.date: 08/24/2009
dmi.bios.vendor: American Megatrends Inc.
dmi.bios.version: 0601
dmi.board.asset.tag: To Be Filled By O.E.M.
dmi.board.name: P5QL-CM
dmi.board.vendor: ASUSTeK Computer INC.
dmi.board.version: Rev X.0x
dmi.chassis.asset.tag: Asset-1234567890
dmi.chassis.type: 3
dmi.chassis.vendor: Chassis Manufacture
dmi.chassis.version: Chassis Version
dmi.modalias: dmi:bvnAmericanMegatrendsInc.:bvr0601:bd08/24/2009:svnSystemmanufacturer:pnSystemProductName:pvrSystemVersion:rvnASUSTeKComputerINC.:rnP5QL-CM:rvrRevX.0x:cvnChassisManufacture:ct3:cvrChassisVersion:
dmi.product.name: System Product Name
dmi.product.version: System Version
dmi.sys.vendor: System manufacturer

Lukav (lukav) wrote :
Lukav (lukav) wrote :

As a hint, it seams that disabling DRI in xorg.conf resolves the issue

Brad Figg (brad-figg) on 2011-08-18
Changed in linux (Ubuntu):
status: New → Confirmed
Steve Conklin (sconklin) wrote :

Can you tell us which previous version you updated from?

Can you boot the older kernel using grub and does the problem go away if you do?

Knowing which version worked will help us find this.

Thanks!

Robert Hooker (sarvatt) wrote :

Since you can still SSH in, while it is frozen can you run intel_gpu_dump > intel_gpu_dump.txt and attach that as well as copy over the /var/log/Xorg.0.log and /var/log/Xorg.0.log.old to attach to the bug? From your dmesg I see you are also hitting this bug

https://bugs.launchpad.net/ubuntu/+source/linux/+bug/828465

Changed in linux (Ubuntu):
status: Confirmed → Incomplete
Lukav (lukav) wrote :

Here are the file requested.
I've just rebooted in 2.6.32-33 which is the only other one I have installed, so it must be the previous.

So far so good, but please bare in mind that the bug is occurring randomly, so there is no guarantee yet that this version works file. I'll give it a couple of days to test and if it freezes again I'll let you know.

Regards

Seth Forshee (sforshee) wrote :

This BUG_ON appears to have just been extra paranoia, not strictly necessary, and in any case not something we need to explode on. It was later removed in upstream commit e39a01501b228e1be2037d5bddccae2a820af902.

I've posted a build at the following link that removes the bug statement. Please install and test to see whether or not you see any more freezes or any other problems that weren't present previously, and report your results back here. Thanks!

http://people.canonical.com/~sforshee/lp828550/linux-2.6.32-34.73~lp828550v201108191554/

Changed in linux (Ubuntu):
assignee: nobody → Seth Forshee (sforshee)
importance: Undecided → High
David Clayton (dcstar) wrote :

Just to add a possibly unrelated issue, the install of the 2.6.32-34-generic kernel on my 10.04 system has broken my VMware Player updating (system eventually hangs requiring power cycle) - even after the revised updates released in the last day or so. As well the original -34 kernel package even stopped my System Monitor running!

My system works fine booting on the 2.6.32-33 kernel, the -34 version is no good for me.

emarkay (mrk) wrote :

David, see
https://bugs.launchpad.net/ubuntu/+source/linux/+bug/825207
regarding System Monitor, etc.

alessandro ciancaglini (alo) wrote :

Still problem also with 2.6.32-34.74 just released... 2.6.32-33 works fine for me.

Seth Forshee (sforshee) wrote :

alessandro: Can you please test the kernel from comment #6? Thanks!

Lukav (lukav) wrote :

Second day using the kernel in comment #6 and there is no problem. It seams to be fixed there.

Tim Gardner (timg-tpi) on 2011-08-23
Changed in linux (Ubuntu):
status: Incomplete → Invalid
Changed in linux (Ubuntu Lucid):
assignee: nobody → Seth Forshee (sforshee)
status: New → Fix Committed
alessandro ciancaglini (alo) wrote :
Download full text (3.8 KiB)

This is the result with the kernel in #6

Aug 23 23:35:33 marte kernel: [ 99.556970] BUG: unable to handle kernel paging request at fffffff3
Aug 23 23:35:33 marte kernel: [ 99.556984] IP: [<c024d582>] vma_stop+0x12/0x30
Aug 23 23:35:33 marte kernel: [ 99.557000] *pde = 00855067 *pte = 00000000
Aug 23 23:35:33 marte kernel: [ 99.557010] Oops: 0000 [#32] SMP
Aug 23 23:35:33 marte kernel: [ 99.557018] last sysfs file: /sys/devices/pci0000:00/0000:00:1d.7/usb2/2-0:1.0/uevent
Aug 23 23:35:33 marte kernel: [ 99.557025] Modules linked in: aes_i586 aes_generic rfcomm binfmt_misc ppdev sco bridge stp bnep l2cap joydev snd_hda_codec_idt ipt_REJECT ipt_LOG xt_limit xt_tcpudp ipt_addrtype xt_state snd_hda_intel snd_hda_codec snd_hwdep snd_pcm_oss snd_mixer_oss ip6table_filter ip6_tables snd_pcm nf_nat_irc snd_seq_dummy snd_seq_oss nf_conntrack_irc arc4 snd_seq_midi nf_nat_ftp nf_nat snd_rawmidi nf_conntrack_ipv4 nf_defrag_ipv4 pcmcia nf_conntrack_ftp nf_conntrack iptable_filter snd_seq_midi_event iwlagn ip_tables btusb x_tables bluetooth snd_seq iwlcore dell_wmi snd_timer snd_seq_device mac80211 led_class yenta_socket rsrc_nonstatic snd dell_laptop dcdbas psmouse coretemp pcmcia_core serio_raw cfg80211 soundcore snd_page_alloc lp parport fbcon tileblit font bitblit softcursor vga16fb vgastate i915 ohci1394 drm_kms_helper ieee1394 drm i2c_algo_bit intel_agp agpgart tg3 video output
Aug 23 23:35:33 marte kernel: [ 99.557201]
Aug 23 23:35:33 marte kernel: [ 99.557209] Pid: 2104, comm: lsof Tainted: G D (2.6.32-34-generic #73~lp828550v201108191554) Latitude D830
Aug 23 23:35:33 marte kernel: [ 99.557217] EIP: 0060:[<c024d582>] EFLAGS: 00210213 CPU: 0
Aug 23 23:35:33 marte kernel: [ 99.557225] EIP is at vma_stop+0x12/0x30
Aug 23 23:35:33 marte kernel: [ 99.557230] EAX: f53e7940 EBX: f53e7940 ECX: c05a2878 EDX: fffffff3
Aug 23 23:35:33 marte kernel: [ 99.557236] ESI: f33cb840 EDI: fffffff3 EBP: f2eddf10 ESP: f2eddf0c
Aug 23 23:35:33 marte kernel: [ 99.557242] DS: 007b ES: 007b FS: 00d8 GS: 00e0 SS: 0068
Aug 23 23:35:33 marte kernel: [ 99.557249] Process lsof (pid: 2104, ti=f2edc000 task=f2c33fc0 task.ti=f2edc000)
Aug 23 23:35:33 marte kernel: [ 99.557254] Stack:
Aug 23 23:35:33 marte kernel: [ 99.557257] f53e7940 f2eddf1c c024d8a3 f3136000 f2eddf64 c02253ed 00001000 000000d0
Aug 23 23:35:33 marte kernel: [ 99.557275] <0> 00000000 fffffff3 09975298 f33cb868 00001000 00000000 f33c4900 fffb25d8
Aug 23 23:35:33 marte kernel: [ 99.557294] <0> f375e098 00000000 00000000 f33c4900 00001000 09975298 f2eddf8c c020a80f
Aug 23 23:35:33 marte kernel: [ 99.557313] Call Trace:
Aug 23 23:35:33 marte kernel: [ 99.557322] [<c024d8a3>] ? m_stop+0x13/0x30
Aug 23 23:35:33 marte kernel: [ 99.557332] [<c02253ed>] ? seq_read+0x16d/0x3a0
Aug 23 23:35:33 marte kernel: [ 99.557343] [<c020a80f>] ? vfs_read+0x9f/0x1a0
Aug 23 23:35:33 marte kernel: [ 99.557351] [<c0225280>] ? seq_read+0x0/0x3a0
Aug 23 23:35:33 marte kernel: [ 99.557363] [<c058f0f0>] ? do_page_fault+0x160/0x3a0
Aug 23 23:35:33 marte kernel: [ 99.557370] [<c020a9c2>] ? sys_read+0x42/0x70
Aug 23 23:35:33 marte kernel: [ 99.557380] [<c0...

Read more...

Seth Forshee (sforshee) wrote :

alessandro: Did you ever see that problem before this kernel? Is it reproducible?

It may be possible that the original patches that introduced the BUG_ON and this error are related, but it's difficult to tell. I'll take a look and see if I can find any connection.

Andy Whitcroft (apw) wrote :

@Seth -- that latest panic reported in comment #12 has the classic signature for the /proc/environ CVE fix that was missing the extra panic fix. I strongly suspect its unrelated to the bug in hand.

Herton R. Krzesinski (herton) wrote :

Yes, the oops on comment #12 should have been handled by the extra panic fix, not related to this bug.

Also, the fix for this bug is a regression fix, also was already verified to fix the issue. Marking as verification-done-lucid.

tags: added: verification-done-lucid
Launchpad Janitor (janitor) wrote :
Download full text (16.9 KiB)

This bug was fixed in the package linux - 2.6.32-34.77

---------------
linux (2.6.32-34.77) lucid-proposed; urgency=low

  [Steve Conklin]

  * Release Tracking Bug
    - LP: #849228

  [ Upstream Kernel Changes ]

  * Revert "drm/i915: Remove BUG_ON from i915_gem_evict_something"
  * Revert "drm/i915: Periodically flush the active lists and requests"
  * Revert "drm/i915/evict: Ensure we completely cleanup on failure"
  * Revert "drm/i915: Maintain LRU order of inactive objects upon access by
    CPU (v2)"
  * Revert "drm/i915: Implement fair lru eviction across both rings. (v2)"
  * Revert "drm/i915: Move the eviction logic to its own file."
  * Revert "drm/i915: prepare for fair lru eviction"

linux (2.6.32-34.76) lucid-proposed; urgency=low

  [Steve Conklin]

  * Release Tracking Bug
    - LP: #836914

  [ Upstream Kernel Changes ]

  * Revert "drm/nv50-nvc0: work around an evo channel hang that some people
    see"
  * Revert "eCryptfs: Handle failed metadata read in lookup"
  * Revert "tunnels: fix netns vs proto registration ordering"

linux (2.6.32-34.75) lucid-proposed; urgency=low

  [Herton R. Krzesinski]

  * Release Tracking Bug
    - LP: #832332

  [ Upstream Kernel Changes ]

  * drm/i915: Remove BUG_ON from i915_gem_evict_something
    - LP: #828550

linux (2.6.32-34.74) lucid-proposed; urgency=low

  [Herton R. Krzesinski]

  * Release Tracking Bug
    - LP: #828375

  [ Upstream Kernel Changes ]

  * proc: fix oops on invalid /proc/<pid>/maps access, CVE-2011-1020
    - LP: #813026
    - CVE-2011-1020

linux (2.6.32-34.73) lucid-proposed; urgency=low

  [Herton R. Krzesinski]

  * Release Tracking Bug
    - LP: #824148

  [ Tim Gardner ]

  * SAUCE: rtl8192se: Force a build for a 2.6/3.0 kernel
    - LP: #805494
  * [Config] Add enic/fnic to udebs
    - LP: #801610

  [ Upstream Kernel Changes ]

  * tty: icount changeover for other main devices, CVE-2010-4076,
    CVE-2010-4077
    - LP: #720189
    - CVE-2010-4077
  * fs/partitions/efi.c: corrupted GUID partition tables can cause kernel
    oops
    - LP: #795418
    - CVE-2011-1577
  * ftrace: Only update the function code on write to filter files
    - LP: #802383
  * kmemleak: Do not return a pointer to an object that kmemleak did not
    get
    - LP: #802383
  * CPU hotplug, re-create sysfs directory and symlinks
    - LP: #802383
  * Fix memory leak in cpufreq_stat
    - LP: #802383
  * powerpc/kexec: Fix memory corruption from unallocated slaves
    - LP: #802383
  * powerpc/oprofile: Handle events that raise an exception without
    overflowing
    - LP: #802383
  * mtd: mtdconcat: fix NAND OOB write
    - LP: #802383
  * x86, 64-bit: Fix copy_[to/from]_user() checks for the userspace address
    limit
    - LP: #802383
  * ext3: Fix fs corruption when make_indexed_dir() fails
    - LP: #802383
  * jbd: Fix forever sleeping process in do_get_write_access()
    - LP: #802383
  * jbd: fix fsync() tid wraparound bug
    - LP: #802383
  * ext4: release page cache in ext4_mb_load_buddy error path
    - LP: #802383
  * Fix Ultrastor asm snippet
    - LP: #802383
  * x86, amd: Do not enable ARAT feature on AMD processors below family
    0x12
    - LP: #802383
  * x86, ...

Changed in linux (Ubuntu Lucid):
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers